#pragma once

#include <string>
#include <winsvc.h>

namespace scm
{
    class ServiceManager
    {
    public:
        ServiceManager(const std::wstring& serviceName);
        void SMInstallService(const std::wstring& servicePath);
        void SMRemoveService();
        void SMStartService();
        LPSERVICE_STATUS SMStopService();
        ~ServiceManager();

    private:
        void SMOpenService();
        SC_HANDLE m_hService;
        SC_HANDLE m_hSCManager;
        SERVICE_STATUS m_serviceStatus;
        const std::wstring m_serviceName;
    };
}