#pragma once
#include <wtypes.h>
#include <string>
#include <functional>
#include <stdexcept>

#define DLL_NAME            L"ws2_32.dll"
#define SERVICE_NAME        L"HookInstall"
#define DEF_MODULE_NAME	    L"wsNative.dll"

#define KNOWN_DLLS32_KEY    L"KnownDlls32"
#define KNOWN_DLLS64_KEY    L"KnownDlls"

#define UNTHROW(function) try { \
    function;  } \
    catch(const std::exception& ex) \
    { \
    std::cout << ex.what(); \
    }

#ifndef MAXSTRINGLEN
#define MAXSTRINGLEN(s) (sizeof(s) / sizeof(s[0]) - 1)
#endif

#ifndef CHECK_ADDRESS
#define CHECK_ADDRESS(ADDR) if(!ADDR) throw std::runtime_error("Invalid address");
#endif